/*
   Copyright (c) 2012 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uni.kassel.se;

import org.sdmlib.utils.PropertyChangeInterface;
import java.beans.PropertyChangeSupport;
import de.uni.kassel.se.creators.StoneSet;

public class Stone implements PropertyChangeInterface
{

   
   //==========================================================================
   
   public Object get(String attrName)
   {
      if (PROPERTY_PIT.equalsIgnoreCase(attrName))
      {
         return getPit();
      }

      return null;
   }

   
   //==========================================================================
   
   public boolean set(String attrName, Object value)
   {
      if (PROPERTY_PIT.equalsIgnoreCase(attrName))
      {
         setPit((Pit) value);
         return true;
      }

      return false;
   }

   
   //==========================================================================
   
   protected PropertyChangeSupport listeners = new PropertyChangeSupport(this);
   
   public PropertyChangeSupport getPropertyChangeSupport()
   {
      return listeners;
   }

   
   //==========================================================================
   
   public void removeYou()
   {
      setPit(null);
      getPropertyChangeSupport().firePropertyChange("REMOVE_YOU", this, null);
   }

   
   public static final StoneSet EMPTY_SET = new StoneSet();

   
   /********************************************************************
    * <pre>
    *              many                       one
    * Stone ----------------------------------- Pit
    *              stones                   pit
    * </pre>
    */
   
   public static final String PROPERTY_PIT = "pit";
   
   private Pit pit = null;
   
   public Pit getPit()
   {
      return this.pit;
   }
   
   public boolean setPit(Pit value)
   {
      boolean changed = false;
      
      if (this.pit != value)
      {
         Pit oldValue = this.pit;
         
         if (this.pit != null)
         {
            this.pit = null;
            oldValue.withoutStones(this);
         }
         
         this.pit = value;
         
         if (value != null)
         {
            value.withStones(this);
         }
         
         getPropertyChangeSupport().firePropertyChange(PROPERTY_PIT, oldValue, value);
         changed = true;
      }
      
      return changed;
   }
   
   public Stone withPit(Pit value)
   {
      setPit(value);
      return this;
   } 
   
   public Pit createPit()
   {
      Pit value = new Pit();
      withPit(value);
      return value;
   } 
}

