package de.uni.kassel.se.creators;

import java.util.LinkedHashSet;
import org.sdmlib.serialization.interfaces.SendableEntityCreator;
import org.sdmlib.serialization.json.JsonIdMap;
import org.sdmlib.serialization.json.SDMLibJsonIdMap;

public class CreatorCreator
{
   public static LinkedHashSet<SendableEntityCreator> creatorSet = null;
   
   public static LinkedHashSet<SendableEntityCreator> getCreatorSet()
   {
      if (creatorSet == null)
      {
         creatorSet = new LinkedHashSet<SendableEntityCreator>();
         creatorSet.add(new de.uni.kassel.se.creators.MancalaCreator());
         creatorSet.add(new de.uni.kassel.se.creators.MancalaPOCreator());
         creatorSet.add(new de.uni.kassel.se.creators.PlayerCreator());
         creatorSet.add(new de.uni.kassel.se.creators.PlayerPOCreator());
         creatorSet.add(new de.uni.kassel.se.creators.PitCreator());
         creatorSet.add(new de.uni.kassel.se.creators.PitPOCreator());
         creatorSet.add(new de.uni.kassel.se.creators.StoneCreator());
         creatorSet.add(new de.uni.kassel.se.creators.StonePOCreator());
         creatorSet.add(new de.uni.kassel.se.creators.KalahCreator());
         creatorSet.add(new de.uni.kassel.se.creators.KalahPOCreator());
         creatorSet.addAll(org.sdmlib.models.pattern.creators.CreatorCreator.getCreatorSet());
      }
      
      return creatorSet;
   }

   public static JsonIdMap createIdMap(String sessionID)
   {
      JsonIdMap jsonIdMap = new SDMLibJsonIdMap().withSessionId(sessionID);
      
      jsonIdMap.addCreator(getCreatorSet());

      return jsonIdMap;
   }
}

