package de.uni.kassel.se.creators;

import org.sdmlib.models.pattern.PatternObject;
import de.uni.kassel.se.Kalah;
import de.uni.kassel.se.creators.KalahSet;
import org.sdmlib.models.pattern.AttributeConstraint;

public class KalahPO extends PatternObject<KalahPO, Kalah>
{
   public KalahSet allMatches()
   {
      this.setDoAllMatches(true);
      
      KalahSet matches = new KalahSet();

      while (this.getPattern().getHasMatch())
      {
         matches.add((Kalah) this.getCurrentMatch());
         
         this.getPattern().findMatch();
      }
      
      return matches;
   }
   
   public KalahPO hasNr(int value)
   {
      AttributeConstraint constr = (AttributeConstraint) new AttributeConstraint()
      .withAttrName(Kalah.PROPERTY_NR)
      .withTgtValue(value)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier())
      .withPattern(this.getPattern());
      
      this.getPattern().findMatch();
      
      return this;
   }
   
   public int getNr()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Kalah) getCurrentMatch()).getNr();
      }
      return 0;
   }
   
   public KalahPO withNr(int value)
   {
      if (this.getPattern().getHasMatch())
      {
         ((Kalah) getCurrentMatch()).setNr(value);
      }
      return this;
   }
   
}

