/*
   Copyright (c) 2012 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uni.kassel.se.creators;

import java.util.LinkedHashSet;
import org.sdmlib.models.modelsets.ModelSet;
import de.uni.kassel.se.Kalah;
import org.sdmlib.models.modelsets.StringList;
import org.sdmlib.models.modelsets.intList;
import java.util.List;

public class KalahSet extends LinkedHashSet<Kalah> implements ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Kalah elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uni.kassel.se.Kalah";
   }


   public KalahSet with(Kalah value)
   {
      this.add(value);
      return this;
   }
   
   public KalahSet without(Kalah value)
   {
      this.remove(value);
      return this;
   }
   public intList getNr()
   {
      intList result = new intList();
      
      for (Kalah obj : this)
      {
         result.add(obj.getNr());
      }
      
      return result;
   }

   public KalahSet withNr(int value)
   {
      for (Kalah obj : this)
      {
         obj.withNr(value);
      }
      
      return this;
   }

}

