package de.uni.kassel.se.creators;

import de.uni.kassel.se.creators.CreatorCreator;
import org.sdmlib.serialization.interfaces.EntityFactory;
import org.sdmlib.serialization.json.JsonIdMap;
import de.uni.kassel.se.Mancala;

public class MancalaCreator extends EntityFactory
{
   private final String[] properties = new String[]
   {
      Mancala.PROPERTY_PLAYERS,
      Mancala.PROPERTY_PITS,
   };
   
   public String[] getProperties()
   {
      return properties;
   }
   
   public Object getSendableInstance(boolean reference)
   {
      return new Mancala();
   }
   
   public Object getValue(Object target, String attrName)
   {
      return ((Mancala) target).get(attrName);
   }
   
   public boolean setValue(Object target, String attrName, Object value, String type)
   {
      return ((Mancala) target).set(attrName, value);
   }
   
   public static JsonIdMap createIdMap(String sessionID)
   {
      return CreatorCreator.createIdMap(sessionID);
   }

   
   //==========================================================================
   
   @Override
   public void removeObject(Object entity)
   {
      ((Mancala) entity).removeYou();
   }
}

