package de.uni.kassel.se.creators;

import org.sdmlib.models.pattern.PatternObject;
import de.uni.kassel.se.Mancala;
import de.uni.kassel.se.creators.MancalaSet;
import org.sdmlib.models.pattern.PatternLink;
import de.uni.kassel.se.creators.PlayerPO;
import org.sdmlib.models.pattern.LinkConstraint;
import de.uni.kassel.se.creators.MancalaPO;
import de.uni.kassel.se.Player;
import de.uni.kassel.se.creators.PlayerSet;
import de.uni.kassel.se.creators.PitPO;
import de.uni.kassel.se.Pit;
import de.uni.kassel.se.creators.PitSet;

public class MancalaPO extends PatternObject<MancalaPO, Mancala>
{
   public MancalaSet allMatches()
   {
      this.setDoAllMatches(true);
      
      MancalaSet matches = new MancalaSet();

      while (this.getPattern().getHasMatch())
      {
         matches.add((Mancala) this.getCurrentMatch());
         
         this.getPattern().findMatch();
      }
      
      return matches;
   }
   
   
   //==========================================================================
   
   public void init(String p0, String p1)
   {
      if (this.getPattern().getHasMatch())
      {
          ((Mancala) getCurrentMatch()).init( p0,  p1);
      }
   }

   public PlayerPO hasPlayers()
   {
      PlayerPO result = new PlayerPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Mancala.PROPERTY_PLAYERS, result);
      
      return result;
   }
   
   public MancalaPO hasPlayers(PlayerPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Mancala.PROPERTY_PLAYERS)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }
   
   public PlayerSet getPlayers()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Mancala) this.getCurrentMatch()).getPlayers();
      }
      return null;
   }
   
   public PitPO hasPits()
   {
      PitPO result = new PitPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Mancala.PROPERTY_PITS, result);
      
      return result;
   }
   
   public MancalaPO hasPits(PitPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Mancala.PROPERTY_PITS)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }
   
   public PitSet getPits()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Mancala) this.getCurrentMatch()).getPits();
      }
      return null;
   }
   
}

