/*
   Copyright (c) 2012 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uni.kassel.se.creators;

import java.util.LinkedHashSet;
import org.sdmlib.models.modelsets.ModelSet;
import de.uni.kassel.se.Mancala;
import org.sdmlib.models.modelsets.StringList;
import de.uni.kassel.se.Player;
import de.uni.kassel.se.Pit;

public class MancalaSet extends LinkedHashSet<Mancala> implements ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Mancala elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uni.kassel.se.Mancala";
   }


   public MancalaSet with(Mancala value)
   {
      this.add(value);
      return this;
   }
   
   public MancalaSet without(Mancala value)
   {
      this.remove(value);
      return this;
   }
   
   //==========================================================================
   
   public MancalaSet init(String p0, String p1)
   {
      for (Mancala obj : this)
      {
         obj.init( p0,  p1);
      }
      return this;
   }

   public PlayerSet getPlayers()
   {
      PlayerSet result = new PlayerSet();
      
      for (Mancala obj : this)
      {
         result.addAll(obj.getPlayers());
      }
      
      return result;
   }
   public MancalaSet withPlayers(Player value)
   {
      for (Mancala obj : this)
      {
         obj.withPlayers(value);
      }
      
      return this;
   }

   public MancalaSet withoutPlayers(Player value)
   {
      for (Mancala obj : this)
      {
         obj.withoutPlayers(value);
      }
      
      return this;
   }

   public PitSet getPits()
   {
      PitSet result = new PitSet();
      
      for (Mancala obj : this)
      {
         result.addAll(obj.getPits());
      }
      
      return result;
   }
   public MancalaSet withPits(Pit value)
   {
      for (Mancala obj : this)
      {
         obj.withPits(value);
      }
      
      return this;
   }

   public MancalaSet withoutPits(Pit value)
   {
      for (Mancala obj : this)
      {
         obj.withoutPits(value);
      }
      
      return this;
   }

}

