package de.uni.kassel.se.creators;

import org.sdmlib.models.pattern.Pattern;
import de.uni.kassel.se.creators.MancalaPO;
import de.uni.kassel.se.Mancala;
import de.uni.kassel.se.creators.PlayerPO;
import de.uni.kassel.se.Player;
import de.uni.kassel.se.creators.PitPO;
import de.uni.kassel.se.Pit;
import de.uni.kassel.se.creators.StonePO;
import de.uni.kassel.se.Stone;
import de.uni.kassel.se.creators.KalahPO;
import de.uni.kassel.se.Kalah;

public class ModelPattern extends Pattern
{
   public ModelPattern()
   {
      super(CreatorCreator.createIdMap("hg"));
   }
   
   public ModelPattern startCreate()
   {
      super.startCreate();
      return this;
   }

   public MancalaPO hasElementMancalaPO()
   {
      MancalaPO value = new MancalaPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public MancalaPO hasElementMancalaPO(Mancala hostGraphObject)
   {
      MancalaPO value = new MancalaPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public PlayerPO hasElementPlayerPO()
   {
      PlayerPO value = new PlayerPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public PlayerPO hasElementPlayerPO(Player hostGraphObject)
   {
      PlayerPO value = new PlayerPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public PitPO hasElementPitPO()
   {
      PitPO value = new PitPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public PitPO hasElementPitPO(Pit hostGraphObject)
   {
      PitPO value = new PitPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public StonePO hasElementStonePO()
   {
      StonePO value = new StonePO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public StonePO hasElementStonePO(Stone hostGraphObject)
   {
      StonePO value = new StonePO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public KalahPO hasElementKalahPO()
   {
      KalahPO value = new KalahPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public KalahPO hasElementKalahPO(Kalah hostGraphObject)
   {
      KalahPO value = new KalahPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

}


