/*
   Copyright (c) 2012 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uni.kassel.se.creators;

import java.util.LinkedHashSet;
import org.sdmlib.models.modelsets.ModelSet;
import de.uni.kassel.se.Pit;
import org.sdmlib.models.modelsets.StringList;
import org.sdmlib.models.modelsets.intList;
import java.util.List;
import de.uni.kassel.se.Mancala;
import de.uni.kassel.se.Player;
import de.uni.kassel.se.Stone;

public class PitSet extends LinkedHashSet<Pit> implements ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Pit elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uni.kassel.se.Pit";
   }


   public PitSet with(Pit value)
   {
      this.add(value);
      return this;
   }
   
   public PitSet without(Pit value)
   {
      this.remove(value);
      return this;
   }
   
   //==========================================================================
   
   public PitSet moveStones()
   {
      for (Pit obj : this)
      {
         obj.moveStones();
      }
      return this;
   }

   public intList getNr()
   {
      intList result = new intList();
      
      for (Pit obj : this)
      {
         result.add(obj.getNr());
      }
      
      return result;
   }

   public PitSet withNr(int value)
   {
      for (Pit obj : this)
      {
         obj.withNr(value);
      }
      
      return this;
   }

   public MancalaSet getMancala()
   {
      MancalaSet result = new MancalaSet();
      
      for (Pit obj : this)
      {
         result.add(obj.getMancala());
      }
      
      return result;
   }
   public PitSet withMancala(Mancala value)
   {
      for (Pit obj : this)
      {
         obj.withMancala(value);
      }
      
      return this;
   }

   public PlayerSet getPlayer()
   {
      PlayerSet result = new PlayerSet();
      
      for (Pit obj : this)
      {
         result.add(obj.getPlayer());
      }
      
      return result;
   }
   public PitSet withPlayer(Player value)
   {
      for (Pit obj : this)
      {
         obj.withPlayer(value);
      }
      
      return this;
   }

   public PitSet getNext()
   {
      PitSet result = new PitSet();
      
      for (Pit obj : this)
      {
         result.add(obj.getNext());
      }
      
      return result;
   }
   public PitSet withNext(Pit value)
   {
      for (Pit obj : this)
      {
         obj.withNext(value);
      }
      
      return this;
   }

   public PitSet getPrevious()
   {
      PitSet result = new PitSet();
      
      for (Pit obj : this)
      {
         result.add(obj.getPrevious());
      }
      
      return result;
   }
   public PitSet withPrevious(Pit value)
   {
      for (Pit obj : this)
      {
         obj.withPrevious(value);
      }
      
      return this;
   }

   public StoneSet getStones()
   {
      StoneSet result = new StoneSet();
      
      for (Pit obj : this)
      {
         result.addAll(obj.getStones());
      }
      
      return result;
   }
   public PitSet withStones(Stone value)
   {
      for (Pit obj : this)
      {
         obj.withStones(value);
      }
      
      return this;
   }

   public PitSet withoutStones(Stone value)
   {
      for (Pit obj : this)
      {
         obj.withoutStones(value);
      }
      
      return this;
   }

}

