package de.uni.kassel.se.creators;

import org.sdmlib.models.pattern.PatternObject;
import de.uni.kassel.se.Stone;
import de.uni.kassel.se.creators.StoneSet;
import org.sdmlib.models.pattern.PatternLink;
import de.uni.kassel.se.creators.PitPO;
import org.sdmlib.models.pattern.LinkConstraint;
import de.uni.kassel.se.creators.StonePO;
import de.uni.kassel.se.Pit;

public class StonePO extends PatternObject<StonePO, Stone>
{
   public StoneSet allMatches()
   {
      this.setDoAllMatches(true);
      
      StoneSet matches = new StoneSet();

      while (this.getPattern().getHasMatch())
      {
         matches.add((Stone) this.getCurrentMatch());
         
         this.getPattern().findMatch();
      }
      
      return matches;
   }
   
   public PitPO hasPit()
   {
      PitPO result = new PitPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Stone.PROPERTY_PIT, result);
      
      return result;
   }
   
   public StonePO hasPit(PitPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Stone.PROPERTY_PIT)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }
   
   public Pit getPit()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Stone) this.getCurrentMatch()).getPit();
      }
      return null;
   }
   
}

