/*
   Copyright (c) 2012 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uni.kassel.se.creators;

import java.util.LinkedHashSet;
import org.sdmlib.models.modelsets.ModelSet;
import de.uni.kassel.se.Stone;
import org.sdmlib.models.modelsets.StringList;
import de.uni.kassel.se.Pit;

public class StoneSet extends LinkedHashSet<Stone> implements ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Stone elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uni.kassel.se.Stone";
   }


   public StoneSet with(Stone value)
   {
      this.add(value);
      return this;
   }
   
   public StoneSet without(Stone value)
   {
      this.remove(value);
      return this;
   }
   public PitSet getPit()
   {
      PitSet result = new PitSet();
      
      for (Stone obj : this)
      {
         result.add(obj.getPit());
      }
      
      return result;
   }
   public StoneSet withPit(Pit value)
   {
      for (Stone obj : this)
      {
         obj.withPit(value);
      }
      
      return this;
   }

}

