package de.uni.kassel.se;
import org.sdmlib.models.classes.ClassModel;
import org.sdmlib.models.classes.Clazz;
import org.sdmlib.models.classes.Role.R;


public class MancalaModelCreation {

	private final static String INT = "int";
	private final static String STRING = "String";
	
	public static void main(String[] args) {
		ClassModel model = new ClassModel("de.uni.kassel.se");
		
		//create clazzes
		Clazz mancalaClazz = model.createClazz("Mancala");
		Clazz playerClazz = model.createClazz("Player",
				"name", STRING);
		Clazz pitClazz = model.createClazz("Pit",
				"nr", INT);
		Clazz stoneClazz = model.createClazz("Stone");
		Clazz kalahClazz = model.createClazz("Kalah");
		kalahClazz.withSuperClass(pitClazz);
		
		//create methods
		mancalaClazz.withMethods("init(String,String)", "void");
		pitClazz.withMethods("moveStones()","void");
		
		//create assocs
		mancalaClazz.withAssoc(playerClazz, "players", R.MANY, "mancala", R.ONE);
		mancalaClazz.withAssoc(pitClazz, "pits", R.MANY, "mancala", R.ONE);
		
		pitClazz.withAssoc(playerClazz, "player", R.ONE, "pits", R.MANY);
		pitClazz.withAssoc(pitClazz, "next", R.ONE, "previous", R.ONE);
		pitClazz.withAssoc(stoneClazz, "stones", R.MANY, "pit", R.ONE);
		
		model.generate("genSrc");
		
		model.dumpClassDiag("genSrc", "classDiagMancala");
	}

}
